#ifndef ELOHIMSCRIPT_LEXTOKENKIND_HPP
#define ELOHIMSCRIPT_LEXTOKENKIND_HPP

#include <cstdint>
namespace ElohimScript::Parser {
    enum class LexTokenKind : uint8_t {
        Unknown,
        EndOfFile,
        Whitespace,

        // Symbols
        StarSymbol,
        StarStarSymbol,
        SlashSymbol,
        PercentSymbol,
        PlusSymbol,
        MinusSymbol,
        LessThanEqualsSymbol,
        LessThanSymbol,
        GreaterThanEqualsSymbol,
        GreaterThanSymbol,
        OpenParenthesisSymbol,
        CloseParenthesisSymbol,
        EqualsEqualsSymbol,
        ExclamationMarkEqualsSymbol,
        QuestionMarkSymbol,
        ColonSymbol,
        EqualsSymbol,
        PlusEqualsSymbol,
        MinusEqualsSymbol,
        StarEqualsSymbol,
        SlashEqualsSymbol,
        PercentEqualsSymbol,
        StarStarEqualsSymbol,
        PlusPlusSymbol,
        MinusMinusSymbol,
        AmpersandSymbol,
        CommaSymbol,
        OpenCurlyParenthesisSymbol,
        CloseCurlyParenthesisSymbol,
        SemicolonSymbol,
        VerticalLineSymbol,
        CaretSymbol,
        TildeSymbol,
        LessThanLessThanSymbol,
        GreaterThanGreaterThanSymbol,
        GreaterThanGreaterThanGreaterThanSymbol,
        AmpersandEqualsSymbol,
        VerticalLineEqualsSymbol,
        CaretEqualsSymbol,
        LessThanLessThanEqualsSymbol,
        GreaterThanGreaterThanEqualsSymbol,
        GreaterThanGreaterThanGreaterThanEqualsSymbol,
        DotSymbol,
        AmpersandAmpersandSymbol,
        VerticalLineVerticalLineSymbol,
        ExclamationMarkSymbol,
        OpenBlockParenthesisSymbol,
        CloseBlockParenthesisSymbol,
        CaretCaretSymbol,
        AtSymbol,
        ExclamationMarkIsSymbol,
        ColonColonSymbol,

        // Misc
        FloatToken,
        IntegerToken,
    };
}

#endif // ELOHIMSCRIPT_LEXTOKENKIND_HPP
